use derive_more::From;
use strum_macros::IntoStaticStr;
use wasm_bindgen::JsValue;

#[derive(From, IntoStaticStr)]
pub enum FetchFileError {
    #[strum(serialize = "Failed to fetch file")]
    Request(JsValue),
    #[strum(serialize = "Failed to read fetched file to string")]
    ReadToString,
}

impl ToString for FetchFileError {
    fn to_string(&self) -> String {
        use FetchFileError::*;
        match self {
            Request(error) => error.as_string(),
            _ => None,
        }
        .unwrap_or_else(|| "".to_string())
    }
}
