use derive_more::From;
use strum_macros::IntoStaticStr;
use wasm_bindgen::JsValue;

#[derive(From, IntoStaticStr)]
pub enum ReadFileError {
    #[strum(serialize = "No file chosen")]
    NoFile,
    #[strum(serialize = "Failed to open file")]
    TextAwait(JsValue),
    #[strum(serialize = "Failed to parse file to string")]
    ParseToString,
}

impl ToString for ReadFileError {
    fn to_string(&self) -> String {
        use ReadFileError::*;
        match self {
            TextAwait(error) => error.as_string(),
            _ => None,
        }
        .unwrap_or_else(|| "".to_string())
    }
}
