use derive_more::From;
use strum_macros::IntoStaticStr;

use super::ReadFileError;

#[derive(From, IntoStaticStr)]
pub enum ReadKleError {
    ReadFile(ReadFileError),
    #[strum(serialize = "Failed to parse KLE JSON")]
    Serde(serde_json::Error),
}

impl ToString for ReadKleError {
    fn to_string(&self) -> String {
        use ReadKleError::*;
        match self {
            ReadFile(error) => error.to_string(),
            Serde(error) => error.to_string(),
        }
    }
}
